<?php

/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       http://example.com
 * @since      1.0.0
 *
 * @package    VIWCPF_Woocommerce_Product_Filters
 * @subpackage VIWCPF_Woocommerce_Product_Filters/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    VIWCPF_Woocommerce_Product_Filters
 * @subpackage VIWCPF_Woocommerce_Product_Filters/includes
 * @author     Villatheme
 */
class VIWCPF_Woocommerce_Product_Filters_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'pofily-woocommerce-product-filters',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

		$get_viwcpf_params = new VIWCPF_Woocommerce_Product_Filters_Data();
		$key               = $get_viwcpf_params->get_params( 'key' );

		if ( class_exists( 'VillaTheme_Plugin_Check_Update' ) ) {
			new VillaTheme_Plugin_Check_Update (
				VIWCPF_VERSION,                    // current version
				'https://villatheme.com/wp-json/downloads/v3',  // update path
				'pofily-woocommerce-product-filters/pofily-woocommerce-product-filters.php',                  // plugin file slug
				'pofily-woocommerce-product-filters', '102284', $key
			);
			$setting_url = admin_url( 'admin.php?page=viwcpf-woocommerce-product-filters-settings' );
			new VillaTheme_Plugin_Updater( 'pofily-woocommerce-product-filters/pofily-woocommerce-product-filters.php', 'pofily-woocommerce-product-filters', $setting_url );
		}

		if ( class_exists( 'VillaTheme_Support_Pro' ) ) {
			new VillaTheme_Support_Pro(
				array(
					'support'   => 'pofily-woocommerce-product-filters',
					'docs'      => 'https://docs.villatheme.com/?item=pofily',
					'review'    => 'pofily-woocommerce-product-filters',
					'css'       => VIWCPF_CSS,
					'image'     => '',
					'slug'      => 'pofily-woocommerce-product-filters',
					'menu_slug' => 'viwcpf-woocommerce-product-filters',
					'version'   => VIWCPF_VERSION
				)
			);
		}

	}


}
